

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   RAYO Batch 1.02                                               *
    *   Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under AFPL.                      *
    *   See AFPL.htm for details.                        2004-08-11   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



#include <windows.h>
#include <process.h>
#include <stdio.h>

#define GSDLLEXPORT __declspec(dllimport)
#include "ghostscript/iapi.h"
#include "class_cjoblist.h"
#include "resource.h"


gs_main_instance * minst;
CJobList joblist;
HANDLE hMutex = NULL;
HWND my = NULL;
UINT uCurrent = 0;
char szCurrent[ _MAX_PATH ] = "";

bool bRunning = true;
bool bShown = false;


void parse()
{
	char * szBeg       = GetCommandLine();
	char * szCur       = szBeg;
	char * szLastBeg   = szBeg;

	bool bInsideQuote  = false;
	bool bWaitchar     = true;

	while( *szCur != '\0' )
	{
		switch( *szCur )
		{
			case '\"':
			{
				if( bInsideQuote )
				{
					joblist.queue( szLastBeg, szCur - szLastBeg );
				}

				bInsideQuote  = !bInsideQuote;
				bWaitchar     = true;

				break;
			}
			case ' ':
			{
				if( !bInsideQuote && !bWaitchar )
				{
					joblist.queue( szLastBeg, szCur - szLastBeg );
					bWaitchar = true;
				}

				break;
			}
			default:
			{
				if( bWaitchar )
				{
					szLastBeg = szCur;
					bWaitchar = false;
				}

				// break;
			}
		}
		szCur++;
	}

	if( !bWaitchar )
	{
		joblist.queue( szLastBeg, szCur - szLastBeg );
	}
}



void jobthread( PVOID pvoid )
{
	char szFull[ _MAX_PATH ] = "";
	while( joblist.dequeue( szFull ) )
	{
		// Get long filename
		char szDrive[ _MAX_DRIVE ] = "";
		char szDir[ _MAX_DIR	] = "";

		// Split it up
		_splitpath( szFull, szDrive, szDir, NULL, NULL );

		// Convert short to long path
		GetLongPathName( szDir, szDir, _MAX_DIR );

		// Convert short to long file
		WIN32_FIND_DATA fd;
		HANDLE h = FindFirstFile( szFull, &fd );

		if( h != INVALID_HANDLE_VALUE )
		{
			// Search last dot
			char * szSearch = fd.cFileName + strlen( fd.cFileName ) - 1;
			while( ( *szSearch != '.' ) && ( szSearch > fd.cFileName ) )
			{
				szSearch--;
			}

			// Skip non-ps
			if( strncmp( szSearch, ".ps", 3 ) )
			{
				continue;
			}


			if( !bShown )
			{
				ShowWindow( my, SW_SHOW );
				bShown = true;
			}


			// Copy full filename
			_snprintf( szFull, _MAX_PATH, "%s%s%s", szDrive, szDir, fd.cFileName );


			// Update status
			strcpy( szCurrent, fd.cFileName );
			uCurrent++;

			char szBuffer[ 512 ] = "";
			wsprintf( szBuffer, "[%u/%u] Processing \"%s\"...", uCurrent, joblist.get_max(), szCurrent );
			SetDlgItemText( my, IDC_MSG, szBuffer );


			// Call ghostscript
			int code;
			int gsargc = 10;

			char * gsargv[ 10 ];
			gsargv[ 0 ] = new char [  7 ]; strcpy( gsargv[ 0 ], "ps2pdf" );
			gsargv[ 1 ] = new char [ 10 ]; strcpy( gsargv[ 1 ], "-dNOPAUSE" );
			gsargv[ 2 ] = new char [  8 ]; strcpy( gsargv[ 2 ], "-dBATCH" );
			gsargv[ 3 ] = new char [  8 ]; strcpy( gsargv[ 3 ], "-dSAFER" );
			gsargv[ 4 ] = new char [ 18 ]; strcpy( gsargv[ 4 ], "-sDEVICE=pdfwrite" );

				gsargv[ 5 ] = new char [ strlen( szFull ) + 14 ]; strcpy( gsargv[ 5 ], "-sOutputFile=" );
				strcat( gsargv[ 5 ], szFull ); strcat( gsargv[ 5 ], ".pdf" );
	
			gsargv[ 6 ] = new char [  3 ]; strcpy( gsargv[ 6 ], "-c" );
			gsargv[ 7 ] = new char [ 13 ]; strcpy( gsargv[ 7 ], ".setpdfwrite" );
			gsargv[ 8 ] = new char [  3 ]; strcpy( gsargv[ 8 ], "-f" );
		
				gsargv[ 9 ] = new char [ strlen( szFull ) ]; strcpy( gsargv[ 9 ], szFull );

    
			code = gsapi_new_instance(&minst, NULL);
		    code = gsapi_init_with_args(minst, gsargc, gsargv);
			gsapi_exit(minst);

			gsapi_delete_instance(minst);


			// Free allocated memory
			for( int i = 0; i < 10; i++ )
			{
				delete [] gsargv[ i ];
			}


			Sleep( 500 );
		}
	}
	
	EndDialog( my, FALSE );
	bRunning = false;
}



BOOL CALLBACK wndproc_progress( HWND hwnd, UINT message, WPARAM wp, LPARAM lp )
{
	switch( message )
	{
		case WM_INITDIALOG:
		{
			my = hwnd;

			SetWindowText( hwnd, "RAYO Batch" );
			// ShowWindow( hwnd, SW_HIDE );

			_beginthread( jobthread, 0, NULL );
			
			break;
		}
		case WM_COPYDATA:
		{
			COPYDATASTRUCT * pcds = (COPYDATASTRUCT*)lp;

			joblist.queue( ( char * )pcds->lpData, pcds->cbData );

			char szBuffer[ 512 ] = "";
			wsprintf( szBuffer, "[%u/%u] Processing \"%s\"", uCurrent, joblist.get_max(), szCurrent );
			SetDlgItemText( my, IDC_MSG, szBuffer );

			break;
		}
	}
	return 0;
}



int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE, LPSTR, int )
{
	// Only one running instance
	hMutex = CreateMutex( NULL, TRUE, "RAYO BATCH MUTEX" );
	if( GetLastError() == ERROR_ALREADY_EXISTS )
	{
		// Running instance found

		// Parse commandline
		parse();

		if( joblist.get_max() )
		{
			HWND papa = NULL;
			while( true )
			{
				papa = FindWindow( "#32770", "RAYO Batch" );
				if( papa != NULL )
				{
					// Let papa do our work
					char szFilename[ _MAX_PATH ] = "";
					while( joblist.dequeue( szFilename ) )
					{
						COPYDATASTRUCT cds;
						cds.cbData = strlen( szFilename );
						cds.dwData = 0;
						cds.lpData = szFilename;
	
						SendMessage( papa, WM_COPYDATA, NULL, ( LPARAM )( COPYDATASTRUCT * )&cds );
					}
					break;
				}
			}
		}
		return 0;
	}

	// Parse commandline
	parse();
	
	if( joblist.get_max() )
	{
		HWND hwnd = CreateDialog( hInstance, MAKEINTRESOURCE( IDD_PROGRESS ), NULL, wndproc_progress );

		// Main loop
		MSG msg;
		while( bRunning && GetMessage( &msg, NULL, 0, 0 ) )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}
	else
	{
		MessageBox( 0, "RAYO Batch 1.02\nCopyright  2004 Sebastian Pipping  \n<webmaster@hartwork.org>\n\n--> http://www.hartwork.org\n\n\nTHIS PROGRAM IS PROVIDED\n  WITHOUT ANY WARRANTY!\n\n\nUSAGE:\n\n    rayo <file1> <file2> ...\n ", "RAYO Batch", MB_ICONINFORMATION );
	}

	// Release mutex
	ReleaseMutex( hMutex );

	return 0;
}